/**
 * Copyright (c) IBM Japan 2013. All rights reserved.
 */
package net.dependableos.dcase.toolchain.rhapsodyextension.model;

import com.telelogic.rhapsody.core.*;

/**
 * D-Casẽfvf̂AGbW`̂̂ǗNX
 * ijIn Context Of, Supported By
 */
public class DEdge {
	
	/** Namel */
	protected String name; // ex. In_Context_Of_1
	
	/** Display Namel */
	protected String displayName; // ex. In_Context_Of_\
	
	/** Base Class */
	protected String metaClassBase; // ex. Dependency
	
	/** Stereotype */
	protected String metaClass; // ex. InContextOf
	
	/** bp[Ώۂ̃fvf */
	protected IRPDependency element;
	
	/** GbW̌̃m[h */
	protected DNode nSrc;
	
	/** GbW̐̃m[h */
	protected DNode nTrg;
	
	/**
	 * GbW`D-Casefvf̃RXgN^ <br>
	 * ̃fꗗw肵fvfÃfvf΁ÃfvfbvB
	 * ̃fvfȂ΁AfvfVK쐬ăbvB
	 * @param name@fvf̖
	 * @param displayName fvf̕\
	 * @param metaClass fvf̃XeI^Cv
	 * @param prj fvf܂ރvWFNg
	 * @param pkg fvf܂ރpbP[W
	 * @param nSrc GbW̌̃m[h
	 * @param nTrg GbW̐̃m[h
	 */
	public DEdge(String name, String displayName, String metaClass, IRPProject prj, IRPPackage pkg, DNode nSrc, DNode nTrg){
		this.name = name;
		this.displayName = displayName;
		this.metaClassBase = "Dependency";
		this.metaClass = metaClass;
		this.nSrc = nSrc;
		this.nTrg = nTrg;
		
		// fvfȂΒǉ
		this.element = (IRPDependency) pkg.findNestedElementRecursive(name, metaClass);
		if(element == null){
			this.element = (IRPDependency) nSrc.getElement().addDependencyTo(nTrg.getElement());
			element.addStereotype(metaClass, metaClassBase);
			element.setName(name);
			element.setDisplayName(displayName);
		}
		
	}
	
	/**
	 * fvf擾
	 * @return fvf
	 */
	public IRPDependency getElement(){
		return element;
	}
	
	/**
	 * ^Oɐݒǉ <br>
	 * ^Ol null ̏ꍇ́Aݒ񂪂ȂƔfA^OǉȂ  <br>
	 * ^Ol󕶎̏ꍇ́Aݒ񂪂ƔfA󕶎^Oɒǉ
	 * @param tagName ǉΏۂ̃^O
	 * @param tagValue ǉΏۂ̃^Ol
	 */
	public void setTag(String tagName, String tagValue) {
		// ^Ol null ̏ꍇ̓^OǉȂ
		if (tagValue == null) {
			return;
		}
		
		// ̃^Oɑ݂ꍇ́A^OlXV
		IRPTag tag = (IRPTag)element.findNestedElement(tagName, "Tag");
		if(tag == null) {
			tag = (IRPTag)element.addNewAggr("Tag", tagName);
		}
		element.setTagValue(tag, tagValue);
	}
	
	/**
	 * ^O̐ݒ擾 <br>
	 * w肵^O^O݂Ȃꍇ́Anull Ԃ
	 * @param tagName 擾Ώۂ̃^O
	 * @return 擾^Ol
	 */
	public String getTag(String tagName) {
		IRPTag tag = element.getTag(tagName);
		String tagValue = null;
		if(tag != null) {
			tagValue = tag.getValue();
		}
		return tagValue;
	}
	
	/**
	 * GbW̌̃m[h擾
	 * @return GbW̌̃m[h
	 */
	public DNode getSourceDNode() {
		return this.nSrc;
	}
	
	/**
	 * GbW̐̃m[h擾
	 * @return GbW̐̃m[h
	 */
	public DNode getTargetDNode() {
		return this.nTrg;
	}
}
