/**
 * Copyright (c) IBM Japan 2013. All rights reserved.
 */
package net.dependableos.dcase.toolchain.rhapsodyextension.model;

import java.util.Iterator;

import com.telelogic.rhapsody.core.*;

/**
 * D-Casẽfvf̂Am[h`̂̂ǗNX
 * ijGoal, Strategy, Context
 */
public class DNode {
	
	/** Namel */
	protected String name; // ex. Test1
	
	/** Display Namel */
	protected String displayName; // ex. ACC͈S
	
	/** Base Class */
	protected String metaClassBase; // ex. Comment
	
	/** Stereotype */
	protected String metaClass; // ex. Goal
	
	/** bp[Ώۂ̃fvf */
	protected IRPComment element;
	
	/**
	 * m[h`D-Casefvf̃RXgN^ <br>
	 * ̃fꗗw肵fvfÃfvf΁ÃfvfbvB
	 * ̃fvfȂ΁AfvfVK쐬ăbvB
	 * @param name@fvf̖
	 * @param displayName fvf̕\
	 * @param metaClass fvf̃XeI^Cv
	 * @param prj fvf܂ރvWFNg
	 * @param pkg fvf܂ރpbP[W
	 */
	public DNode(String name, String displayName, String metaClass, IRPProject prj, IRPPackage pkg){
		this.name = name;
		this.displayName = displayName;
		this.metaClassBase = "Comment";
		this.metaClass = metaClass;
		
		// fvfȂΒǉ
		this.element = (IRPComment) pkg.findNestedElementRecursive(name, metaClassBase);
		if(element == null) {
			element = (IRPComment) pkg.addNewAggr(metaClassBase, name);
			element.addStereotype(metaClass, metaClassBase);
			element.setDisplayName(displayName);
		}
	}
	
	/**
	 * m[h`D-Casefvf̃RXgN^ <br>
	 * ̃fꗗw肵fvfÃfvf΁ÃfvfbvB
	 * ̃fvfȂ΁AfvfVK쐬ăbvB
	 * @param element Ώۂ̃fvf
	 * @param metaClass fvf̃XeI^Cv
	 */
	public DNode(IRPModelElement element, String metaClass){
		this.name = element.getName();
		this.displayName = element.getDisplayName();
		this.metaClassBase = "Comment";
		this.metaClass = metaClass;
		
		if(element instanceof IRPComment){
			this.element = (IRPComment) element;
		}
		else {
			System.err.println("Error DNode : Type mismatch " + element.getClass());
			
			// fvfȂΒǉ
//			this.element = (IRPComment) pkg.findNestedElementRecursive(name, metaClass);
//			if(this.element == null){
//				element = (IRPComment) pkg.addNewAggr(metaClassBase, name);
//				element.addStereotype(metaClass, metaClassBase);
//				element.setDisplayName(displayName);
//			}
		}
	}
	
	/**
	 * fvf擾
	 * @return fvf
	 */
	public IRPComment getElement(){
		return element;
	}
	
	/**
	 * nCp[Nǉ
	 * @param name nCp[N
	 * @param dispName nCp[N\
	 * @param trgElm ÑfGg
	 */
	public void addHyperLink(String name, String dispName, IRPModelElement trgElm){
		IRPHyperLink link = (IRPHyperLink) element.addNewAggr("HyperLink", name);
		link.setDisplayName(dispName);
		link.setDisplayOption((char) 0, dispName);
		link.setTarget(trgElm);
	}
	
	/**
	 * nCp[Nǉ
	 * @param name nCp[N
	 * @param dispName nCp[N\
	 * @param trgURL NURL
	 */
	public void addHyperLink(String name, String dispName, String trgURL){
		if ( trgURL == null || trgURL.equals("") ) {
			return;
		}
		IRPHyperLink link = (IRPHyperLink) element.addNewAggr("HyperLink", name);
		link.setDisplayName(dispName);
		link.setDisplayOption((char) 0, dispName);
		link.setURL(trgURL);
	}
	
	/**
	 * ǉnCp[N̕Ԃ <br>
	 * ԂnCp[N͍ŏɌURLSysMLfvfł <br>
	 * nCp[NȂꍇ́AnullԂ
	 * @return ǉnCp[N̕
	 */
	public String getAHyperLink() {
		String aHyperLink = null;
		IRPCollection col = element.getHyperLinks();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPHyperLink link = (IRPHyperLink) itr.next();
				String trgName = null;
				
				// URLݒ肵Ăꍇ
				trgName = link.getURL();
				if ( trgName != null && !trgName.equals("") ) {
					aHyperLink = trgName;
					return aHyperLink;
				}
				
				// ^[Qbgݒ肵Ăꍇ
				IRPModelElement elm = link.getTarget();
				if ( elm != null ) {
					trgName = elm.getDisplayName();
					if ( !trgName.equals("") ) {
						aHyperLink = trgName;
						return aHyperLink;
					}
				}
			}
		}
		return aHyperLink;
	}
	
	/**
	 * ^Oɐݒǉ <br>
	 * ^Ol null ̏ꍇ́Aݒ񂪂ȂƔfA^OǉȂ  <br>
	 * ^Ol󕶎̏ꍇ́Aݒ񂪂ƔfA󕶎^Oɒǉ
	 * @param tagName ǉΏۂ̃^O
	 * @param tagValue ǉΏۂ̃^Ol
	 */
	public void setTag(String tagName, String tagValue) {
		// ^Ol null ̏ꍇ̓^OǉȂ
		if (tagValue == null) {
			return;
		}
		
		// ̃^Oɑ݂ꍇ́A^OlXV
		IRPTag tag = (IRPTag)element.findNestedElement(tagName, "Tag");
		if(tag == null) {
			tag = (IRPTag)element.addNewAggr("Tag", tagName);
		}
		element.setTagValue(tag, tagValue);
	}
	
	/**
	 * ^O̐ݒ擾 <br>
	 * w肵^O^O݂Ȃꍇ́Anull Ԃ
	 * @param tagName 擾Ώۂ̃^O
	 * @return 擾^Ol
	 */
	public String getTag(String tagName) {
		IRPTag tag = element.getTag(tagName);
		String tagValue = null;
		if(tag != null) {
			tagValue = tag.getValue();
		}
		return tagValue;
	}
	
	
	public String getModelXMLElement() {
		String xml_str = "";
		return xml_str;
	}
	
}
