package sample;
import java.util.Iterator;

import com.telelogic.rhapsody.core.*;

public class TestMain {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String test="a0-b1_c2!#$%&'()-=~^|\\@`{}[]+;*:<>,.?/_\" d";
		String testout=test.replaceAll("[!\"#$%&'\\(\\)\\-=~^|\\\\@+;*:`{}\\[\\]<>,.?/ ]", "_");
		System.out.println(test);
		System.out.println(testout);
		
		IRPApplication app = null;
		try{
			app = RhapsodyAppServer.getActiveRhapsodyApplication();
		}
		catch(Exception e){
			System.out.println("Rhapsody is not active.");
			e.printStackTrace();
			System.exit(0);
		}
		IRPProject prj = app.activeProject();
		
		IRPModelElement selectElm = app.getSelectedElement();
		System.out.println("select element : " + selectElm.getDisplayName() + ", " + selectElm.getName() + ", " + selectElm.getInterfaceName());
		
		// show the build number
//		JOptionPane.showMessageDialog(null, "Hello world from SimplePlugin.RhpPluginInit.\n You are using Rhapsody build "	+ app.getBuildNo());
		
		IRPPackage pkg = (IRPPackage) prj.findNestedElement("Default", "Package");
		if(pkg == null){
			pkg = prj.addPackage("Default");
		}
		
		IRPCollection col;
		
		col = app.getSelectedGraphElements();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPGraphElement e = (IRPGraphElement) itr.next();
				System.out.println("g " + e.getInterfaceName());
				// ex. g IRPGraphNode
			}
		}
		else {
			System.out.println("g : no element");
		}
		
		col = prj.getAnnotations();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPModelElement e = (IRPModelElement) itr.next();
				System.out.println("a " + e.getName());
				// ex. g IRPGraphNode
			}
		}
		else {
			System.out.println("a : no annotation");
		}
		
		col = prj.getNestedElementsRecursive();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPModelElement e = (IRPModelElement) itr.next();
				System.out.println("s " + e.getInterfaceName() + "\t" + e.getName() + "\t" + e.getDisplayName());
				
				if(e.getDisplayName().equals("ACC͈S")){
					System.out.println("s " + e.getInterfaceName() + "\t" + e.getName() + "\t" + e.getDisplayName());
					IRPTag enew = (IRPTag)e.findNestedElement("status", "Tag");
					if(enew==null){
						enew = (IRPTag)e.addNewAggr("Tag", "status");
					}
					e.setTagValue(enew, "OK!v");
					System.out.println("Gatcha!");
					System.out.println("*********************status : " + e.getTag("status").getValue());
					System.out.println("*********************no name: " + e.getTag("status_noname"));
					
					IRPCollection cc = e.getNestedElements();
					Iterator<?> ii = cc.toList().iterator();
					while(ii.hasNext()){
						IRPModelElement ee = (IRPModelElement) ii.next();
						System.out.println("ssss " + ee.getInterfaceName() + "\t" + ee.getName() + "\t" + ee.getDisplayName());
					}
				}
				// ex. s IRPComment	goal_35	ACC͈S
			}
		}
		else {
			System.out.println("s : no element");
		}
		
		
		IRPModelElement e0 = app.getSelectedElement();
		if ( e0 != null ) {
			System.out.println("e : " + app.getSelectedElement().getName());
			// ex. e : ACC_01
		}
		else {
			System.out.println("e : no element");
		}
		
		col = app.getListOfSelectedElements();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPModelElement e = (IRPModelElement) itr.next();
				System.out.println("c " + e.getName());
				// c ACC_01
				// c Test1

			}
		}
		else {
			System.out.println("c : no element");
		}
		

		col = app.getListOfSiteProperties();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			if ( col.getCount() == 0) {
				System.out.println("sp : size 0");
			}
			while ( itr.hasNext() ) {
				IRPModelElement e = (IRPModelElement) itr.next();
				System.out.println("sp " + e.getName());
			}
		}
		else {
			System.out.println("sp : no site");
		}
		
		

		
		
		
		// fvfȂΒǉ
		IRPComment cm1 = (IRPComment) prj.findNestedElementRecursive("Test1", "Comment");
		if(cm1 == null) {
			cm1 = (IRPComment) pkg.addNewAggr("Comment", "Test1");
			cm1.addStereotype("Goal", "Comment");
			cm1.setDisplayName("ACC͈Sł");
			IRPHyperLink hpl = (IRPHyperLink) cm1.addNewAggr("HyperLink", "HyperLinkName0");
			hpl.setDisplayName("dispName");
			hpl.setTarget(cm1);
		}
		
		IRPComment cm2 = (IRPComment) prj.findNestedElementRecursive("Test2", "Comment");
		if(cm2 == null) {
			cm2 = (IRPComment) pkg.addNewAggr("Comment", "Test2");
			cm2.addStereotype("Context", "Comment");
			cm2.setDisplayName("fBy_reB");
		}
		
		IRPDependency d12 = (IRPDependency) cm1.addDependencyTo(cm2);
		d12.addStereotype("InContextOf", "Dependency");
		d12.setName("in_context_of_1");
		d12.setDisplayName("\");
		
		// }Ƀfvfǉ
		IRPObjectModelDiagram diagram = (IRPObjectModelDiagram) prj.findNestedElementRecursive("d-case diagram_0", "D-Case Diagram");
		if(diagram == null){
			diagram = prj.addObjectModelDiagram("d-case diagram_0");
			diagram.setDisplayName("\");
			diagram.addStereotype("D-Case Diagram", "ObjectModelDiagram");
		}
		
		IRPGraphNode n1 = diagram.addNewNodeForElement(cm1, 100, 200, 80, 60);
		cm1.setIsShowDisplayName(1);
		
		IRPGraphNode n2 = diagram.addNewNodeForElement(cm2, 300, 200, 80, 60);
		cm2.setIsShowDisplayName(1);
		
		IRPGraphEdge e12 = diagram.addNewEdgeForElement(d12, n1, 100, 230, n2, 300, 230);
		
		
		
		// ʒu擾
		col = n2.getAllGraphicalProperties();
		if ( col != null ){
//		if ( col != null && col.getCount() > 0){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPGraphicalProperty e = (IRPGraphicalProperty) itr.next();
				System.out.println("gp : " + e.getKey() + "\t" + e.getValue());
				// gp : Position	300,200
				// gp : Height	60
				// gp : Width	80
				// gp : TextPosition	0,0
			}
		}
		else {
			System.out.println("s : no element");
		}
		
		// fvfIƂ
		col = app.getSelectedGraphElements();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPGraphElement e = (IRPGraphElement) itr.next();
				IRPModelElement elm = e.getModelObject();
				String sP = e.getGraphicalProperty("Position").getValue();
				String sW = e.getGraphicalProperty("Width").getValue();
				String sH = e.getGraphicalProperty("Height").getValue();
				System.out.println("g " + elm.getDescription() + "\t" + sP+","+sW+","+sH);
				// ex. g IRPGraphNode
				
			}
		}
		else {
			System.out.println("g : no element");
		}
		
		
		
		
//		IRPClassifier cls1 = (IRPClassifier) prj.findNestedElementRecursive("TestClass1", "Object");
//		if(cls1==null){
//			cls1 = (IRPClassifier) pkg.addNewAggr("Object", "TestClass1");
//		}
//		IRPClassifier cls2 = (IRPClassifier) prj.findNestedElementRecursive("TestClass2", "Object");
//		if(cls2==null){
//			cls2 = (IRPClassifier) pkg.addNewAggr("Object", "TestClass2");
//		}
//		cls1.changeTo("Goal");
//		cls2.changeTo("Goal");
//		cls1.addDependency("InContextOf", "InContextOf");
//		IRPDependency dpd = (IRPDependency) cls1.addDependencyTo(cls2);
//		dpd.addStereotype("InContextOf", "Dependency");
//		
//		IRPClassifier c1 = (IRPClassifier) prj.findNestedElementRecursive("G1", "Goal");
//		if(c1==null){
//			c1 = (IRPClassifier) pkg.addNewAggr("Class", "G1");
//		}
//		IRPClassifier c2 = (IRPClassifier) prj.findNestedElementRecursive("G2", "Goal");
//		if(c2==null){
//			c2 = (IRPClassifier) pkg.addNewAggr("Class", "G2");
//		}
//		
//		IRPStereotype styp = (IRPStereotype) prj.findNestedElementRecursive("Goal", "Stereotype");
//		System.out.println(styp);
//		cls1.addSpecificStereotype(styp);
		
		IRPObjectModelDiagram d;
		
		
//		IRPPackage pkgD = (IRPPackage) prj.findNestedElement("D_Case", "Package");
//		IRPPackage packageToUse = (IRPPackage) prj.findNestedElement("AnalysisPkg", "Package");
		
//		IRPClass c = pkg.addClass("TestAPI");
//		IRPClass c2 = (IRPClass) pkg.addNewAggr("Class", "TestObject");
//		IRPCollection types = pkg.getStereotypes();
		
		//stereotypě^Ȃ̂ŃG[
		
//		IRPStereotype t = (IRPStereotype) prj.findNestedElementRecursive("Goal", "Stereotype");
//		System.out.println(t);
//		IRPClass c = (IRPClass) pkg.addNewAggr("Class", "GoalObj");
		
//		c.setStereotype(t);
		
//		IRPStereotype type;
//		System.out.println(types.getCount());
//		for ( int i = 0; i < types.getCount(); i++ ){
//			type = (IRPStereotype) types.getItem(i);
//			System.out.println(type);
//		}
//		c2.setStereotype(type);
		
		System.out.println("End.");
	}

}
